#!/usr/bin/tclsh
# Copyright (c) 2002-2003, Steve McMillen
# All Rights Reservered
#
# Steve McMillen
# stevemc@real.com
#
# Helix Producer Remote Encoder Sample v1.0 August 7, 2003
#
# Library of CGI functions
#
# This code is freely distributable without restriction, but is provided as-is 
# with no waranty expressed or implied. 
#

proc urlDecode {url} {
  regsub -all {\+} $url { } url
  regsub -all {%([0-9a-hA-H][0-9a-hA-H])} $url {[format %c 0x\1]} url
  return [subst $url]
}

proc cgiParse {} {
  global cgi env
  if [info exists env(QUERY_STRING)] {
	 # This comes from GET-style forms
	 foreach {name value} [split $env(QUERY_STRING) &=] {
		set cgi([urlDecode $name]) [urlDecode $value]
	 }
  } 
  if {[info exists env(CONTENT_LENGTH)]} {
	 # This comes from POST-style forms
	 foreach {name value} [split [read stdin $env(CONTENT_LENGTH)] &=] {
		set cgi([urlDecode $name]) [urlDecode $value]
	 }
  } else {
	 # No content-length so it is only safe to read one line
	 foreach {name value} [split [read stdin] &=] {
		set cgi([urlDecode $name]) [urlDecode $value]
	 }
  }
}

proc urlEncode {str} {
 regsub -all {[A-Z,a-z,0-9,+/\.-_]} $str "" chars
 regsub -all (.) $chars "\\1_" o
 set lst [split [string range $o 0 end-1] _]
 foreach c $lst {
	lappend cmap "$c" %[format %x [scan "$c" %c]]
 }
 expr { [info exists cmap]?[string map $cmap $str]:$str }
}


# Call cgiParse to parse the URL parameters and load them into the array 'cgi'
cgiParse
