#!/usr/bin/tclsh
# Copyright (c) 2002-2003, Steve McMillen
# All Rights Reservered
#
# Steve McMillen
# stevemc@real.com
#
# Helix Producer Remote Encoder Sample v1.0 August 7, 2003
#
# Script to edit job files in job library
#
# This code is freely distributable without restriction, but is provided as-is 
# with no waranty expressed or implied. 
#

source options.cfg
set debug 0

# Source in cgi parameters
source cgi-lib.tcl


proc ShowForm { {filename ""} } {
 global cgi JobLibraryDir ScriptsDir
 set jobname $cgi(jobname)
 if [info exists cgi(xml)] {
    set xml $cgi(xml)
 } else {
     if [catch {open "$JobLibraryDir/$jobname" r} result] {
        puts "Content-Type: text/html\n"
        puts "<p style=color:red;>$result</p>"
        puts "<p>&nbsp;</p>"
        puts "<p><a href=$ScriptsDir/library.tcl>Return to Job Library</a></p>"
     }  else {
        set fileID $result
        set xml [read $fileID]
        close $fileID
     }
 }

 puts "Content-Type: text/html\n"
 puts "<html>
 <body>
 <h2>Edit Job File</h2>"

 if {"$filename" != ""} {
   puts "<p style=color:red;>Filename $filename exists already.  Please use an alternate name.</p>"
 }

  puts "  <form name=f method=POST action=$ScriptsDir/edit.tcl>
    <input type=hidden name=oldjobname value='$jobname'>
    <p>Job Name: <input type=text name=jobname value='$jobname' size=60></p>
    <p>Job File Contents:<br><textarea name=xml rows=25 cols=80>$xml</textarea>
    <p><input type=submit value=Submit> 
	 <input type=button onclick=back() value=Cancel>
	 <input type=button value='Select Text' onclick='document.f.xml.focus();document.f.xml.select()'>
	 </p>
  </form>
  </body>
  </html>"
}


proc ReadFormData { } {
    global cgi debug JobLibraryDir

    set jobname $cgi(jobname)
    set oldjobname $cgi(oldjobname)
    set xml $cgi(xml)

    if { [file exists "$JobLibraryDir/$jobname"] && "$jobname" != "$oldjobname" } {
        ShowForm $jobname
        exit
    }
    if $debug {puts "jobname=$jobname"}
    if $debug {puts "XML=$xml"}

    if [catch {open "$JobLibraryDir/$jobname" w} result] {
        puts "Content-Type: text/html\n"
        puts "<pre>ERROR: $result</pre>"
        exit
    } else {
        # Else, file was opened and result is the fileID
        set fileID $result
        puts $fileID "$xml"
        close $fileID
		  catch {file attributes "$JobLibraryDir/$jobname" -permissions oug+wr}
    }

    # Now respond to the browser
    source library.tcl
}


# If user submitted via form, then process the form.  Else, show the form.
if [info exists env(CONTENT_TYPE)] {
    ReadFormData
} else {
    ShowForm
}
