#!/usr/bin/tclsh
# Copyright (c) 2002-2003, Steve McMillen
# All Rights Reservered
#
# Steve McMillen
# stevemc@real.com
#
# Helix Producer Remote Encoder Sample v1.0 August 7, 2003
#
# Script to execute print options in Helix Producer command line (-pa, -ps, -pd)
#
# This code is freely distributable without restriction, but is provided as-is 
# with no waranty expressed or implied. 
#

source options.cfg

# Source in cgi parameters
source cgi-lib.tcl
set opt $cgi(opt)

puts "Content-Type: text/html\n"

# Producer hands if devices are unreadable (bug filed and will be fixed eventually) so need to check permissions first
if { $opt == "pd" } {
	foreach dev {dsp mixer video} {
		if [file exists /dev/$dev] {
			if ![file readable /dev/$dev] {
				puts "Device /dev/$dev not readable.  Check permissions on your devices"
				exit
			}
		}
	}
}

puts "<pre>"
puts "[exec $ProducerDir/producer -$opt]"
puts "</pre>"

