#!/usr/bin/tclsh
# Copyright (c) 2002-2003, Steve McMillen
# All Rights Reservered
#
# Steve McMillen
# stevemc@real.com
#
# Helix Producer Remote Encoder Sample v1.0 August 7, 2003
#
# Script to view running job files
#
# This code is freely distributable without restriction, but is provided as-is 
# with no waranty expressed or implied. 
#

source options.cfg

# Source in cgi parameters
source cgi-lib.tcl

puts "Content-Type: text/html\n"

puts "
<html>
  <head>
    <META HTTP-EQUIV=Refresh CONTENT=5 URL=$ScriptsDir/running.tcl>
    <META HTTP-EQUIV=expires CONTENT='Sat, 01 Jan 2000 00:00:00 GMT'>
  </head>
  <body>
  <h1>Running Jobs</h1>"

  if { [llength [glob -nocomplain "$RunningJobsDir/*"]] == 0 } {
      puts "<p style=color:red>No running jobs.</p>"
      exit
  }
  
  puts "<table border=1 cellspacing=0 cellpadding=2>"

foreach job [glob -nocomplain "$RunningJobsDir/*"] {
    set jobname [file tail $job]
    puts "
    <tr>
      <td>$jobname</td>
      <td><a href=$ScriptsDir/stop.tcl?jobname=[urlEncode $jobname]&action=stop>Stop Job</a></td>
      <td><a href=$ScriptsDir/stop.tcl?jobname=[urlEncode $jobname]&action=cancel>Cancel Job</a></td>
      <td><a href=$ScriptsDir/viewlog.tcl?jobname=[urlEncode $jobname]&action=cancel>View Log</a></td>
    </tr>"
}

puts "
</table>
</HTML>"

